> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rated.network/llms.txt
> Use this file to discover all available pages before exploring further.

# Get validator performance metrics

> This endpoint returns performance metrics (signing rates, proposal rates) for a specific validator.

<Warning>
  <b>Polygon on the Rated API is under maintenance</b>

  Please check our [changelog](/changelog#july-8%2C-2025) for the latest updates.
</Warning>


## OpenAPI

````yaml get /v1/polygon/validators/{validator_id}/performance
openapi: 3.1.0
info:
  title: Rated API
  description: >

    Welcome to Rated API Swagger doc for developers! This doc outlines the Rated
    API functionality and API architecture.


    V0: It is separated into seven categories:


    -   **Validators**: Endpoints to query into individual validator indices or
    aggregations of validator indices.

    -   **Operators**: Endpoints to query into pre-materialized operator
    groupings.

    -   **Network**: Endpoints to query into network aggregate stats.

    -   **Slashings**: Endpoints to query into network aggregate stats.

    -   **Withdrawals (beta)**: Endpoints to query into when a withdrawal is
    expected to land.

    -   **Self Report (beta)**: Endpoint to query into all slashed validators
    and individual slashed validator indices


    V1: It is separated into six categories:

    -   **Overview**: Endpoints encapsulating the current status of operators,
    pools and validators.

    -   **Performance**: Endpoints that dive into performance and effectiveness
    metrics on execution and consensus layer for operators, pools and
    validators.

    -   **Rewards**: Endpoints that dive into relevant metrics around rewards
    and penalties for operators, pools and validators.

    -   **Private Sets**: Endpoints that aggregate custom group of validators
    privately for performance and reward drill downs.

    -   **Metadata**: Endpoints that provide metadata about mappings, slashings
    and APRs for validators, pools and operators.

    -   **Network**: Endpoints that provide network level metrics about
    performance, rewards, and distributions.


    [Terms of Use](https://docs.rated.network/legal/terms/api-terms-of-service)


    [API
    Reference](https://docs.rated.network/rated-api/api-reference/introduction)
  version: '1.0'
servers: []
security: []
paths:
  /v1/polygon/validators/{validator_id}/performance:
    get:
      tags:
        - Polygon Performance
      summary: Get validator performance metrics
      description: >-
        This endpoint returns performance metrics (signing rates, proposal
        rates) for a specific validator.
      operationId: >-
        validator_performance_v1_polygon_validators__validator_id__performance_get
      parameters:
        - name: validator_id
          in: path
          required: true
          schema:
            type: integer
            minimum: 0
            title: Validator Id
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            description: The number of results returned per page
            default: 10
            title: Limit
          description: The number of results returned per page
        - name: offset
          in: query
          required: false
          schema:
            type: integer
            description: The number of results to skip before starting to return
            default: 0
            title: Offset
          description: The number of results to skip before starting to return
        - name: from
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
              - type: string
              - $ref: >-
                  #/components/schemas/networks__polygon__granularity__Granularity
            title: From
        - name: to
          in: query
          required: false
          schema:
            anyOf:
              - {}
              - type: 'null'
            title: To
        - name: granularity
          in: query
          required: false
          schema:
            anyOf:
              - $ref: >-
                  #/components/schemas/networks__polygon__granularity__Granularity
              - type: 'null'
            title: Granularity
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api__schemas__paginator__paginated_response_for_result_model___locals___PaginatedResponseWithResultModel__86
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    networks__polygon__granularity__Granularity:
      type: string
      enum:
        - checkpoint
        - day
      title: Granularity
    api__schemas__paginator__paginated_response_for_result_model___locals___PaginatedResponseWithResultModel__86:
      properties:
        previous:
          anyOf:
            - type: string
            - type: 'null'
          title: Previous
        next:
          anyOf:
            - type: string
            - type: 'null'
          title: Next
        pages:
          type: integer
          minimum: 0
          title: Pages
        results:
          items:
            properties:
              checkpoint:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Checkpoint
              timestamp:
                anyOf:
                  - type: string
                    format: date
                  - type: 'null'
                title: Timestamp
              day:
                anyOf:
                  - type: string
                    format: date
                  - type: 'null'
                title: Day
              fromCheckpoint:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Fromcheckpoint
              toCheckpoint:
                anyOf:
                  - type: integer
                    minimum: 0
                  - type: 'null'
                title: Tocheckpoint
              checkpointSignatureDuties:
                type: integer
                minimum: 0
                title: Checkpointsignatureduties
              checkpointSignatures:
                type: integer
                minimum: 0
                title: Checkpointsignatures
              checkpointProposalDuties:
                type: integer
                minimum: 0
                title: Checkpointproposalduties
              checkpointProposals:
                type: integer
                minimum: 0
                title: Checkpointproposals
              borProposalDuties:
                type: integer
                minimum: 0
                title: Borproposalduties
              borProposals:
                type: integer
                minimum: 0
                title: Borproposals
              checkpointSigningRate:
                type: number
                minimum: 0
                title: Checkpointsigningrate
              checkpointProposalRate:
                type: number
                minimum: 0
                title: Checkpointproposalrate
              borProposalRate:
                type: number
                minimum: 0
                title: Borproposalrate
              effectiveness:
                type: number
                minimum: 0
                title: Effectiveness
            type: object
            required:
              - checkpointSignatureDuties
              - checkpointSignatures
              - checkpointProposalDuties
              - checkpointProposals
              - borProposalDuties
              - borProposals
              - checkpointSigningRate
              - checkpointProposalRate
              - borProposalRate
              - effectiveness
            title: PolygonValidatorPerformance
            examples:
              - borProposalDuties: 10
                borProposalRate: 100
                borProposals: 10
                checkpoint: 53105
                checkpointProposalDuties: 5
                checkpointProposalRate: 100
                checkpointProposals: 5
                checkpointSignatureDuties: 10
                checkpointSignatures: 9
                checkpointSigningRate: 90
                effectiveness: 96
                timestamp: '2021-09-01T00:00:00Z'
              - borProposalDuties: 120
                borProposalRate: 98.3
                borProposals: 118
                checkpointProposalDuties: 48
                checkpointProposalRate: 97.9
                checkpointProposals: 47
                checkpointSignatureDuties: 240
                checkpointSignatures: 235
                checkpointSigningRate: 97.9
                day: '2021-09-01'
                effectiveness: 98
                fromCheckpoint: 53100
                toCheckpoint: 53150
          type: array
          title: Results
      type: object
      required:
        - previous
        - next
        - pages
        - results
      title: PaginatedV1PolygonValidatorPerformanceList
      examples:
        - next: >-
            https://api.rated.network//v1/polygon/validators/{validator_id}/performance?limit=10&offset=30
          pages: 10
          previous: >-
            https://api.rated.network//v1/polygon/validators/{validator_id}/performance?limit=10&offset=10
          results:
            - - borProposalDuties: 10
                borProposalRate: 100
                borProposals: 10
                checkpoint: 53105
                checkpointProposalDuties: 5
                checkpointProposalRate: 100
                checkpointProposals: 5
                checkpointSignatureDuties: 10
                checkpointSignatures: 9
                checkpointSigningRate: 90
                effectiveness: 96
                timestamp: '2021-09-01T00:00:00Z'
              - borProposalDuties: 120
                borProposalRate: 98.3
                borProposals: 118
                checkpointProposalDuties: 48
                checkpointProposalRate: 97.9
                checkpointProposals: 47
                checkpointSignatureDuties: 240
                checkpointSignatures: 235
                checkpointSigningRate: 97.9
                day: '2021-09-01'
                effectiveness: 98
                fromCheckpoint: 53100
                toCheckpoint: 53150
    ErrorResponse:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Error'
          type: array
          title: Detail
      type: object
      required:
        - detail
      title: ErrorResponse
    Error:
      properties:
        loc:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Loc
        msg:
          type: string
          title: Msg
        type:
          type: string
          title: Type
      type: object
      required:
        - msg
        - type
      title: Error
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````